--- /Volumes/TextMate 1.5.4/TextMate.app/Contents/SharedSupport/Support/bin/checknest.rb	2005-08-09 20:51:32.000000000 +0100
+++ /Applications/TextMate.app/Contents/SharedSupport/Support/bin/checknest.rb	2007-03-15 19:32:15.000000000 +0000
@@ -23,6 +23,7 @@
 begin
   open_match = Regexp.new ARGV[0]
   close_match = Regexp.new ARGV[1]
+  open_or_close_match = Regexp.new("%s|%s" % ARGV)
   close_text = ARGV[2]
 rescue
   puts 'ERROR: Ill-formed regex in open or close tag.'
@@ -34,12 +35,14 @@
 levels = 1
 error_text = nil
 pass = false
+debug = false
 ARGV[3..-1].each {|e|
   case e
   when /^-n(\d+)$/: num = $1.to_i
   when /^-l(\d+)$/: levels = $1.to_i
   when /^-e(.+)$/: error_text = $1
   when /^-p$/: pass = true
+  when /^-d$/: debug = true
   end
 }
 
@@ -48,25 +51,32 @@
 line = 1
 while (!num or line<num) and s = $stdin.gets
   dumped = false
-	if s =~ open_match
-		stack.push $~.to_a
-	elsif s =~ close_match
-    e = $~.to_a
-    if e[1..-1] == stack[-1][1..-1]
-		  stack.pop
-    elsif error_text
-      print error_text.gsub(/\$(\d)/) {e[$1.to_i]}
-      dumped = true
+  s.scan(open_or_close_match) do
+    m = $&
+    if m =~ open_match
+      stack.push $~.to_a
+    elsif m =~ close_match
+      e = $~.to_a
+      if e[1..-1] == stack[-1][1..-1]
+        stack.pop
+      elsif error_text
+        print error_text.gsub(/\$(\d)/) {e[$1.to_i]}
+        dumped = true
+      end
+    end
+    if debug
+    	puts "%d: "%line + (stack.map{|a,b| b})*", "
     end
   end
-	line += 1
+  line += 1
   print s if pass and not dumped
 end
 
 # Insert correct closers.
 while levels > 0 and e = stack.pop
-	puts close_text.gsub(/\$(\d)/) {e[$1.to_i]}
+  print close_text.gsub(/\$(\d)/) {e[$1.to_i]}
   levels -= 1
+  print "\n" if levels > 0 and not stack.empty?
 end
 
 # Dump rest of file, if requested.
